/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOEDITAL                                               */
/* Tabela : TIPOEDITAL                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 09/08/2004 - WELBERT G. MOITINHA                                           */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TIPOEDITAL
BEFORE INSERT OR UPDATE OR DELETE
ON TIPOEDITAL FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTPED := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (:OLD.CDTIPOEDITAL <> :NEW.CDTIPOEDITAL ) OR
         (:OLD.NMTIPOEDITAL <> :NEW.NMTIPOEDITAL ) THEN
         :NEW.DTULTATUTPED := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPOEDITAL', '', 'CDTIPOEDITAL='||:OLD.CDTIPOEDITAL||';', SYSDATE);
   END IF;
END;
/
ALTER TABLE TIPOEDITAL MODIFY DTULTATUTPED DEFAULT SYSDATE
/
