/* Sistemas Integrados TECNISA

Nome: LOG_RECEITABRUTA.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   02/01/2012 - Kessiler Almeida S. Rodrigues
*/
CREATE OR REPLACE TRIGGER LOG_RECEITABRUTA
AFTER DELETE OR INSERT OR UPDATE
ON RECEITABRUTA FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(300);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF DELETING THEN
      IF :OLD.CDEMPRESA IS NOT NULL THEN
         V_DESC := V_DESC || ' Empresa=' || :OLD.CDEMPRESA;
      END IF;
      IF :OLD.DTREFRECEITABR IS NOT NULL THEN
         V_DESC := V_DESC || ' DataReferencia=' || TO_CHAR(:OLD.DTREFRECEITABR, 'DD/MM/YYYY');
      END IF;
      IF :OLD.IDSTATUSMES IS NOT NULL THEN
         V_DESC := V_DESC || ' Status=' || :OLD.IDSTATUSMES;
      END IF;
      IF :OLD.VRRECEITABR IS NOT NULL THEN
         V_DESC := V_DESC || ' Valor=' || :OLD.VRRECEITABR;
      END IF;
      IF :OLD.VRSALDONEGMES IS NOT NULL THEN
         V_DESC := V_DESC || ' SaldoNeg=' || :OLD.VRSALDONEGMES;
      END IF;
      IF :OLD.VRSALDOCOMPOE IS NOT NULL THEN
         V_DESC := V_DESC || ' SaldoCompoe=' || :OLD.VRSALDOCOMPOE;
      END IF;
      IF :OLD.VRSALDODEDUZ IS NOT NULL THEN
         V_DESC := V_DESC || ' SaldoDeduz=' || :OLD.VRSALDODEDUZ;
      END IF;
      V_ITPESQ       := :OLD.CDEMPRESA||:OLD.DTREFRECEITABR;
      V_IDTIPOOPER   := '3';
   ELSE
      IF UPDATING THEN
         IF(NVL(:NEW.CDEMPRESA, '!') <> NVL(:OLD.CDEMPRESA, '!')) OR
           (NVL(:NEW.DTREFRECEITABR, SYSDATE) <> NVL(:OLD.DTREFRECEITABR, SYSDATE)) OR
           (NVL(:NEW.IDSTATUSMES, '!') <> NVL(:OLD.IDSTATUSMES, '!')) OR
           (NVL(:NEW.VRRECEITABR, -1) <> NVL(:OLD.VRRECEITABR, -1))     OR
           (NVL(:NEW.VRSALDONEGMES, -1) <> NVL(:OLD.VRSALDONEGMES, -1)) OR
           (NVL(:NEW.VRSALDOCOMPOE, -1) <> NVL(:OLD.VRSALDOCOMPOE, -1)) OR
           (NVL(:NEW.VRSALDODEDUZ, -1) <> NVL(:OLD.VRSALDODEDUZ, -1))   THEN
            V_ITPESQ       := :OLD.CDEMPRESA||:OLD.DTREFRECEITABR;
            V_IDTIPOOPER   := '2';
         END IF;
      ELSE
         V_ITPESQ       := :NEW.CDEMPRESA||:NEW.DTREFRECEITABR;
         V_IDTIPOOPER   := '1';
      END IF;
      IF NVL(:NEW.CDEMPRESA, '!') <> NVL(:OLD.CDEMPRESA, '!') THEN
         V_DESC := V_DESC || ' Empresa=' || :NEW.CDEMPRESA;
      END IF;
      IF NVL(:NEW.DTREFRECEITABR, SYSDATE) <> NVL(:OLD.DTREFRECEITABR, SYSDATE) THEN
         V_DESC := V_DESC || ' DataReferencia=' || TO_CHAR(:NEW.DTREFRECEITABR, 'DD/MM/YYYY');
      END IF;
      IF NVL(:NEW.IDSTATUSMES, '!') <> NVL(:OLD.IDSTATUSMES, '!') THEN
         V_DESC := V_DESC || ' Status=' || :NEW.IDSTATUSMES;
      END IF;
      IF NVL(:NEW.VRRECEITABR, -1) <> NVL(:OLD.VRRECEITABR, -1) THEN
         V_DESC := V_DESC || ' Valor=' || :NEW.VRRECEITABR;
      END IF;
      IF NVL(:NEW.VRSALDONEGMES, -1) <> NVL(:OLD.VRSALDONEGMES, -1) THEN
         V_DESC := V_DESC || ' SaldoNeg=' || :NEW.VRSALDONEGMES;
      END IF;
      IF NVL(:NEW.VRSALDOCOMPOE, -1) <> NVL(:OLD.VRSALDOCOMPOE, -1) THEN
         V_DESC := V_DESC || ' SaldoCompoe=' || :NEW.VRSALDOCOMPOE;
      END IF;
      IF NVL(:NEW.VRSALDODEDUZ, -1) <> NVL(:OLD.VRSALDODEDUZ, -1) THEN
         V_DESC := V_DESC || ' SaldoDeduz=' || :NEW.VRSALDODEDUZ;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   IF (V_DESC IS NOT NULL) AND (V_IDTIPOOPER IS NOT NULL) THEN
      INSERT INTO LOGOPERA
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM,
          DSRDMUSUOPER,
          DSENDUSUOPER,
          DSNMUSUOPER,
          DSMETUSUOPER,
          CDORESPOPER)
       VALUES
         ('RECEITABRUTA',
          SYSDATE,
          NVL(V_NMOPERADOR,' '),
          V_IDTIPOOPER,
          V_DESC,
          V_ITPESQ,
          V_DSSERVERRDM,
          V_DSREMOTEADDR,
          V_DSREMOTEHOST,
          V_DSSERVMETHOD,
          V_DSREMOTEOPER);
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_RECEITABRUTA','5.45.xxx'); END;
/

