/* Tabela TAREFA: Tarefa */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes feitas na tabela TAREFA */
/* Objetivo: Gerar um log que vai registrar as alteraes feitas na tabela TAREFA, utilizando a tabela LOGOPERA.Sero
             registrados  os valores antigos dos campos "Assunto" e "Responsvel", os valores atuais desses campos
             e o operador que realizou a operao. */
/* Data de criao: 19/10/2011 - Paulo Henrique Mariano */

CREATE OR REPLACE TRIGGER LOG_AGE_TAREFA
AFTER UPDATE
ON TAREFA FOR EACH ROW
DECLARE
   V_DSREMOTEADDR VARCHAR2(15);
   V_DSREMOTEHOST VARCHAR2(15);
   V_DSSERVERRDM  VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(30);
   V_DSREMOTEOPER VARCHAR2(12);
   V_DESC         VARCHAR2(400);
   V_ITPESQ       VARCHAR2(40);
   V_NMOPERADOR   VARCHAR2(40);
   V_IDTIPOOPER   VARCHAR2(1);
   V_FILIAL       VARCHAR2(5); 
   V_CDASSUNTO    VARCHAR2(20);
   V_CDOPERRESP   VARCHAR2(20);

BEGIN

   V_DSREMOTEADDR := '';
   V_DSREMOTEHOST := '';
   V_DSSERVERRDM  := '';
   V_DSSERVMETHOD := '';
   V_DSREMOTEOPER := '';
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   V_FILIAL       := '';
   V_CDASSUNTO    := '';
   V_CDOPERRESP   := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
             V_DSREMOTEHOST,
             V_DSSERVERRDM,
             V_DSSERVMETHOD,
             V_DSREMOTEOPER);

  
   IF UPDATING THEN
      IF ((:OLD.CDASSUNTO) <> (:NEW.CDASSUNTO)) THEN
         IF NOT ((:OLD.CDASSUNTO) IS NULL)THEN
            V_DESC := V_DESC||'Assunto anterior: '||:OLD.CDASSUNTO||' ';
         END IF;
         V_DESC := V_DESC||'Assunto atual: ' ||:NEW.CDASSUNTO||' ';
      END IF;

      IF ((:OLD.CDOPERRESP) <>(:NEW.CDOPERRESP)) THEN
         IF NOT ((:OLD.CDOPERRESP) IS NULL)THEN
            V_DESC := V_DESC||'Responsavel Anterior:'||:OLD.CDOPERRESP||' ';
         END IF;
         V_DESC := V_DESC||'Responsavel atual: '||:NEW.CDOPERRESP||' ';
      END IF;

      V_ITPESQ := :OLD.CDFILIAL||:OLD.NRTAREFA;
      V_IDTIPOOPER := '2';
      V_FILIAL := :OLD.CDFILIAL;
   END IF;

   IF NOT (V_DESC IS NULL) THEN
      V_DESC := SUBSTR(V_DESC,1, 300);

      INSERT INTO LOGOPERA (NMTABELA, DTOPERACAO, NMRESPOPER,
                            IDTIPOOPER, DSOPERACAO, CDPESQITEM,
                            DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                            DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
                  VALUES   ('TAREFA', SYSDATE , NVL(V_NMOPERADOR,' '),
                            V_IDTIPOOPER,   V_DESC, V_ITPESQ,
                            V_DSSERVERRDM, V_DSREMOTEADDR,  V_DSREMOTEHOST,
                            V_DSSERVMETHOD,   V_DSREMOTEOPER, V_FILIAL);

   END IF;
END;

/ 
-- VERSAO --
BEGIN ATUVEROBJ('LOG_AGE_TAREFA','5.30.001'); END;
/  
 