ALTER TABLE PRODUTO
ADD USR_DTEXPXML DATE
/

ALTER TABLE FORNECEDOR
ADD USR_DTEXPXML DATE
/

ALTER TABLE CLIENTE
ADD USR_DTEXPXML DATE
/

ALTER TABLE FILIAL
ADD USR_DTEXPXML DATE
/

ALTER TABLE NOTAFISCAL
ADD USR_DTEXPXML DATE
/

CREATE TABLE XML_PARSE(XML_INSERT XMLTYPE)
/

create table HMA_MONITORAINT
(
   IDPROCESSO  VARCHAR2(1)    not null,
   DSTABELA    VARCHAR2(50)   not null,
   CDDADOS     VARCHAR2(50)   not null,
   DSERRO      VARCHAR2(500)  null,
   DTMONITOR   DATE          default SYSDATE not null
)
/

create index USR_WMS_0002_FK on HMA_MONITORAINT (IDPROCESSO asc, CDDADOS asc)
/

CREATE TABLE RETORNO_PEDIDO_OC
(
   EMPRESA           VARCHAR2(10),
   FILIAL            VARCHAR2(10),
   DATAINCLUSAO      DATE,
   CODPEDIDOCOMPRA   VARCHAR2(30),
   CODAGENTE         VARCHAR2(30),
   NFENTRADA         VARCHAR2(30),
   NFSERIE           VARCHAR2(30),
   SEQITEM           INTEGER,
   CODPRODUTO        VARCHAR2(30),
   QUANTIDADE        FLOAT,
   CODUNIDADE        VARCHAR2(5)
)
/

CREATE TABLE RETORNO_ARQ_SEPARA
(
   EMPRESA             VARCHAR2(10),
   FILIAL              VARCHAR2(10),
   DATAINCLUSAO        DATE,
   ORDEMCARREGAMENTO   VARCHAR2(18),
   DEPOSITO_ERP        VARCHAR2(20),
   CODPRODUTO          VARCHAR2(30),
   QUANTIDADE          FLOAT
)
/

ALTER TABLE PARAMFILIAL ADD CDFILWMSMHA VARCHAR2(10)
/

ALTER TABLE PARAMFILIAL ADD CDOPERWMSMHA VARCHAR2(12)
/

ALTER TABLE PARAMFILIAL ADD DSINFWEBSERVICE VARCHAR2(100)
/
create index USR_WMS_0001_FK on PARAMFILIAL (CDFILWMSMHA asc)
/

CREATE TABLE CABEC_ARQ_SEP
(
   CODTRANSACAOERP VARCHAR2(20),
   TIPOGERADOR VARCHAR2(3) DEFAULT 'ERP',
   TIPOINTERFACE VARCHAR2(3) DEFAULT 'INC',
   EMPRESA VARCHAR2(2),
   FILIAL VARCHAR2(10),
   CLIENTEDEPOSITANTE VARCHAR2(3) DEFAULT '006',
   CODDEPOSITO VARCHAR2(20) DEFAULT '1',
   ORDEMCARREGAMENTO VARCHAR2(20),
   CODAGENTE VARCHAR2(20),
   TIPAGENTE VARCHAR2(1) DEFAULT 'A',
   DOCUMENTOREMESSA VARCHAR2(20),
   TIPDOCUMENTO VARCHAR2(1) DEFAULT 'V',
   IDENTIFICADOR VARCHAR2(3),
   CDFILIAL VARCHAR2(4),
   NRLANCTONF VARCHAR2(10),
   CODDEPOSITOERP VARCHAR2(30),
   CONSTRAINT PK_CABEC_ARQ_SEP PRIMARY KEY (CODTRANSACAOERP)
)
/

CREATE TABLE ITEM_ARQ_SEP
(
   CODTRANSACAOERP VARCHAR2(20),
   CODPRODUTO VARCHAR2(20),
   DESPRODUTO VARCHAR2(50),
   SEQITEM INTEGER,
   CODUNIDADE VARCHAR2(10),
   QUANTIDADE FLOAT,
   RETRABALHO VARCHAR2(3) DEFAULT 'Nao',
   VLR_UNITARIO FLOAT,
   CDFILDEST VARCHAR2(4),
   CDFILLANC VARCHAR2(4),
   NRPEDEXOL VARCHAR2(10),
   CDMARCA VARCHAR2(5),
   CDPRODUTO VARCHAR2(10), 
   DTPROGENPEOL DATE,
   CONSTRAINT PK_ITEM_ARQ_SEP PRIMARY KEY (CODTRANSACAOERP, CODPRODUTO, SEQITEM)
)
/

ALTER TABLE PEDIDOEXOL
ADD USR_DTEXPXML DATE
/

ALTER TABLE ITEM_ARQ_SEP
ADD CONSTRAINT FK_XML_ARQ_ESP FOREIGN KEY (CODTRANSACAOERP)
REFERENCES CABEC_ARQ_SEP (CODTRANSACAOERP)
/

ALTER TABLE ITEMPEDEXOL
ADD USR_DTEXPXML DATE
/

CREATE TABLE SAP_SUBGRUPPRODFIL
(
   CDFILIAL    VARCHAR2(4) NOT NULL,
   CDGRUPPROD  VARCHAR2(10) NOT NULL,
   CDSUBGRPROD VARCHAR2(10) NOT NULL,
   CONSTRAINT PK_SUBGRUPPRODFIL PRIMARY KEY (CDFILIAL, CDGRUPPROD, CDSUBGRPROD)
)
/

ALTER TABLE SAP_SUBGRUPPRODFIL
ADD CONSTRAINT FK_SUBGRUPROD FOREIGN KEY (CDGRUPPROD, CDSUBGRPROD)
REFERENCES SUBGRUPPROD (CDGRUPPROD, CDSUBGRPROD)
/

ALTER TABLE SAP_SUBGRUPPRODFIL
ADD CONSTRAINT FK_FILIAL FOREIGN KEY (CDFILIAL)
REFERENCES FILIAL (CDFILIAL)
/

CREATE TABLE USR_LOG_INTEGRACAO
(
   SEQLOG     INTEGER,
   CDLOG      VARCHAR2(20) NOT NULL,
   DSLOG      CLOB,
   OBSLOG     VARCHAR2(200),
   DTINCLUSAO DATE DEFAULT SYSDATE
)
/

CREATE TABLE USR_SAP_FLAG_INTEGRACAO
(
   FLAG_PRODUTO VARCHAR2(1) DEFAULT 'N' NOT NULL,
   FLAG_AGENTE VARCHAR2(1) DEFAULT 'N' NOT NULL,
   FLAG_NFE VARCHAR2(1) DEFAULT 'N' NOT NULL,
   FLAG_NFS VARCHAR2(1) DEFAULT 'N' NOT NULL,
   FLAG_CONCILIACAO VARCHAR2(1) DEFAULT 'N' NOT NULL,
   FLAG_SEPARACAO VARCHAR2(1)
)
/

ALTER TABLE ITEM_ARQ_SEP
ADD TIPDOCUMENTO VARCHAR2(1)
/

ALTER TABLE HMA_MONITORAINT
ADD SEQLOGITEM NUMBER
/

ALTER TABLE USR_LOG_INTEGRACAO
ADD HORAENV DATE;
/

ALTER TABLE USR_LOG_INTEGRACAO
ADD HORAREC DATE
/

CREATE TABLE USR_LOGITEM_INTEGRACAO
(
   SEQLOG NUMBER,
   CDLOG VARCHAR2(20),
   SEQLOGITEM NUMBER,
   CDDADOS VARCHAR2(20),
   OBSLOGITEM VARCHAR2(200),
   HORAENV DATE,
   HORAREC DATE,
   DTINCLUSAO DATE DEFAULT SYSDATE
)
/

ALTER TABLE HMA_MONITORAINT
MODIFY DSERRO VARCHAR2(4000);
/

ALTER TABLE USR_LOG_INTEGRACAO
ADD CONSTRAINT PK_USR_LOG_INTEGRACAO PRIMARY KEY (SEQLOG)
/

ALTER TABLE USR_LOGITEM_INTEGRACAO
ADD CONSTRAINT FK_LOG_INTEGRACAO FOREIGN KEY (SEQLOG) 
REFERENCES USR_LOG_INTEGRACAO(SEQLOG) ON DELETE CASCADE
/

ALTER TABLE USR_LOGITEM_INTEGRACAO
ADD CONSTRAINT PK_USR_LOGITEM_INTEGRACAO PRIMARY KEY (SEQLOGITEM, CDDADOS)
/

ALTER TABLE HMA_MONITORAINT
ADD CONSTRAINT FK_LOGITEM_INTEGRACAO FOREIGN KEY (SEQLOGITEM, CDDADOS)
REFERENCES USR_LOGITEM_INTEGRACAO(SEQLOGITEM, CDDADOS) ON DELETE CASCADE
/

CREATE INDEX IDX_HMA_MONITORAINT ON HMA_MONITORAINT(CDDADOS, SEQLOGITEM)
/

CREATE INDEX IDX_LOGITEM_INTEGRACAO ON USR_LOGITEM_INTEGRACAO (CDDADOS, SEQLOGITEM)
/

CREATE INDEX IDX_LOG_INTEGRACAO ON USR_LOG_INTEGRACAO (SEQLOG)
/

ALTER TABLE ITEM_ARQ_SEP
MODIFY TIPDOCUMENTO VARCHAR2(10)
/


-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZACAO_ESTRUTURA_BD','0.00.000'); END;
/